{ stdenv, fetchgit, python3Packages, nmigen, git }:

python3Packages.buildPythonPackage {
  name = "nmigen-soc";
  version = "harry-fork";

  src = fetchgit {
    # Using harry's fork
    url = "https://github.com/HarryHo90sHK/nmigen-soc";
    rev = "89829244034d65d2bf486052af6646e9abec92fe";
    sha256 = "1dlvyr42shzh61rwj3xgkjr97lvra8vkh7qaxviml7wlw45sfc3h";

    leaveDotGit = true;
  };

  nativeBuildInputs = [ python3Packages.setuptools_scm git ];
  propagatedBuildInputs = [ nmigen ];

  meta = with stdenv.lib; {
    description = "System on Chip toolkit for nMigen";
    homepage    = "https://m-labs.hk";
    license     = licenses.bsd2;
    maintainers = [ maintainers.sb0 ];
  };
}
