{ stdenv, fetchgit, python3Packages, nmigen, git }:

python3Packages.buildPythonPackage {
  name = "nmigen-stdio";
  version = "harry-fork";

  src = fetchgit {
    # Using harry's fork
    url = "https://github.com/HarryHo90sHK/nmigen-stdio";
    rev = "531465f15e80b26a83989f843bda60e6c93babae";
    sha256 = "0ln32r7ldd0pndffw076xj6izl86mn5l9l9xmn5wcwrmiby294m1";

    leaveDotGit = true;
  };

  nativeBuildInputs = [ python3Packages.setuptools_scm git ];
  propagatedBuildInputs = [ nmigen ];

  meta = with stdenv.lib; {
    description = "Industry standard I/O for nMigen";
    homepage    = "https://m-labs.hk";
    license     = licenses.bsd2;
    maintainers = [ maintainers.sb0 ];
  };
}
