{ stdenv, python3Packages, yosys, symbiyosys, yices, git }:

python3Packages.buildPythonPackage rec {
  pname = "nmigen";
  version = "0.1rc1";

  src = python3Packages.fetchPypi {
    inherit pname version;
    sha256 = "13vlxn71ackbh8w05fixyxsjypwjginqy9cc5nydlzr3dbhiziw0";
  };

  checkInputs = [ yosys symbiyosys yices ];
  checkPhase = "python -m unittest discover nmigen.test -v";

  nativeBuildInputs = [ python3Packages.setuptools_scm git ];
  propagatedBuildInputs = [ python3Packages.bitarray python3Packages.pyvcd python3Packages.jinja2 ];

  meta = with stdenv.lib; {
    description = "A refreshed Python toolbox for building complex digital hardware";
    homepage    = "https://m-labs.hk";
    license     = licenses.bsd2;
    maintainers = [ maintainers.sb0 ];
  };
}
